Index: code/trunk/src/libraries/util/output/OutputStream.h
===================================================================
--- code/trunk/src/libraries/util/output/OutputStream.h	(revision 8858)
+++ code/trunk/src/libraries/util/output/OutputStream.h	(revision 8858)
@@ -0,0 +1,122 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @ingroup Output
+    @brief Declaration of the OutputStream class which is used to send output to orxonox::OutputManager.
+*/
+
+#ifndef _OutputStream_H__
+#define _OutputStream_H__
+
+#include "util/UtilPrereqs.h"
+
+#include <sstream>
+
+#include "OutputDefinitions.h"
+
+namespace orxonox
+{
+    /**
+        @brief This class is used to buffer output and send it to OutputManager whenever std::endl is passed to it.
+
+        OutputStream inherits from std::ostringstream and acts like std::cout.
+        This means you can use the << operator to write output to the stream.
+        This class is used by the orxout() function.
+
+        @attention
+        You must end an output message with std::endl, otherwise the message
+        won't be flushed. '\\n' only adds a new line to the message.
+
+        The following code samples are all equivalent:
+        @code
+        OutputStream stream;
+        stream.setOutputAttributes(user_info, context::example());
+        stream << "Hello World" << endl;
+        @endcode
+
+        @code
+        OutputStream stream(user_info, context::example());
+        stream << "Hello World" << endl;
+        @endcode
+
+        @code
+        orxout(user_info, context::example) << "Hello World" << endl;
+        @endcode
+    */
+    class OutputStream : public std::ostringstream
+    {
+        typedef std::ostream& (*EndlType)(std::ostream&);
+
+        public:
+            _UtilExport OutputStream();
+            _UtilExport OutputStream(OutputLevel level, const OutputContextContainer& context);
+            _UtilExport ~OutputStream();
+
+            void _UtilExport setOutputAttributes(OutputLevel level, const OutputContextContainer& context);
+
+            /// @brief Generic << operator which adds output to the stream.
+            template <class T>
+            inline OutputStream& operator<<(const T& val) { return this->output(val); }
+            /// @brief Sends a manipulator to the output stream.
+            inline OutputStream& operator<<(std::ios_base& (*manipulator)(std::ios_base&)) { return this->output(manipulator); }
+            /// @brief Sends a manipulator to the output stream.
+            inline OutputStream& operator<<(std::ios&      (*manipulator)(std::ios&))      { return this->output(manipulator); }
+            /// @brief Sends a manipulator to the output stream and flushes the message if the manipulator is std::endl.
+            inline OutputStream& operator<<(std::ostream&  (*manipulator)(std::ostream&))
+            {
+                if (this->bAcceptsOutput_)
+                {
+                    if (manipulator == static_cast<EndlType>(std::endl))
+                        this->sendMessage(); // send the message to OutputManager
+                    else
+                        return this->output(manipulator); // apply the manipulator
+                }
+                return *this;
+            }
+
+        private:
+            /// @brief Generic function to add values to the output stream, using the inherited << operator from std::ostringstream.
+            template <class T>
+            inline OutputStream& output(const T& val)
+            {
+                if (this->bAcceptsOutput_)
+                    static_cast<std::ostringstream&>(*this) << val;
+                return *this;
+            }
+
+            void _UtilExport sendMessage();
+
+            OutputLevel level_;                     ///< The output level of the current message
+            const OutputContextContainer* context_; ///< The output context of the current message
+            bool bAcceptsOutput_;                   ///< After defining level and context of the following message, this flag is set according to the masks defined in OutputManager. If it is false, the OutputStream will throw away every output sent using the << operator.
+    };
+}
+
+#endif /* _OutputStream_H__ */
Index: code/trunk/src/libraries/util/output/SubcontextOutputListener.cc
===================================================================
--- code/trunk/src/libraries/util/output/SubcontextOutputListener.cc	(revision 8858)
+++ code/trunk/src/libraries/util/output/SubcontextOutputListener.cc	(revision 8858)
@@ -0,0 +1,118 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @brief Implementation of the SubcontextOutputListener interface.
+*/
+
+#include "SubcontextOutputListener.h"
+
+namespace orxonox
+{
+    /**
+        @brief Constructor, initializes the context masks.
+    */
+    SubcontextOutputListener::SubcontextOutputListener(bool bRegister) : OutputListener(bRegister)
+    {
+        this->subcontextsCheckMask_ = context::none;
+        this->subcontextsNoCheckMask_ = context::none;
+    }
+
+    /**
+        @brief Destructor.
+    */
+    SubcontextOutputListener::~SubcontextOutputListener()
+    {
+    }
+
+    /**
+        @brief Overwritten implementation of the function defined by OutputListener.
+
+        Contexts defined with this function are accepted independent of the
+        sub-context. The "final" mask of additional contexts is defined by the
+        combination of this mask and the masks of all accepted sub-contexts.
+    */
+    void SubcontextOutputListener::setAdditionalContextsMask(OutputContextMask mask)
+    {
+        this->subcontextsNoCheckMask_ = mask;
+
+        OutputListener::setAdditionalContextsMask(this->subcontextsCheckMask_ | this->subcontextsNoCheckMask_);
+    }
+
+    /**
+        @brief Defines the set of accepted sub-contexts.
+
+        The masks of sub-contexts in this set are added to the mask of
+        additional contexts, but output is only accepted if the exact
+        sub-context exists in this set.
+    */
+    void SubcontextOutputListener::setAdditionalSubcontexts(const std::set<const OutputContextContainer*>& subcontexts)
+    {
+        this->subcontextsCheckMask_ = context::none;
+        this->subcontexts_.clear();
+
+        // compose the mask of subcontexts and build the set of sub-context-IDs
+        for (std::set<const OutputContextContainer*>::const_iterator it = subcontexts.begin(); it != subcontexts.end(); ++it)
+        {
+            this->subcontextsCheckMask_ |= (*it)->mask;
+            this->subcontexts_.insert((*it)->sub_id);
+        }
+
+        OutputListener::setAdditionalContextsMask(this->subcontextsCheckMask_ | this->subcontextsNoCheckMask_);
+    }
+
+    /**
+        @brief Returns true if this listener accepts output of the given level and context, based on the levels and contexts masks, as well as the set of accepted sub-contexts.
+    */
+    bool SubcontextOutputListener::acceptsOutput(OutputLevel level, const OutputContextContainer& context) const
+    {
+        // check if the output level is accepted by the level mask (independent of the context)
+        if (this->getLevelMask() & level)
+            return true;
+
+        // check if the output level is accepted by the additional contexts level mask
+        if (this->getAdditionalContextsLevelMask() & level)
+        {
+            // check if the output context is accepted by the "no check" mask
+            if (this->subcontextsNoCheckMask_ & context.mask)
+                return true;
+
+            // check if the output context is accepted by the "check" mask
+            if (this->subcontextsCheckMask_ & context.mask)
+            {
+                // check if the output's subcontext is in the set of accepted sub-context
+                if (this->subcontexts_.find(context.sub_id) != this->subcontexts_.end())
+                    return true;
+            }
+        }
+
+        // otherwise we don't accept the output
+        return false;
+    }
+}
Index: code/trunk/src/libraries/util/output/SubcontextOutputListener.h
===================================================================
--- code/trunk/src/libraries/util/output/SubcontextOutputListener.h	(revision 8858)
+++ code/trunk/src/libraries/util/output/SubcontextOutputListener.h	(revision 8858)
@@ -0,0 +1,87 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @ingroup Output
+    @brief Declaration of the SubcontextOutputListener interface which adds the ability to filter sub-contexts to OutputListener.
+*/
+
+#ifndef _SubcontextOutputListener_H__
+#define _SubcontextOutputListener_H__
+
+#include "util/UtilPrereqs.h"
+
+#include <set>
+
+#include "OutputListener.h"
+
+namespace orxonox
+{
+    /**
+        @brief This class extends the basic OutputListener interface and adds the ability to filter sub-contexts.
+
+        Defining additional contexts with setAdditionalContextsMask() enables
+        all sub-contexts of these additional contexts. To accept only some
+        particular sub-contexts, setAdditionalSubcontexts() has to be used.
+        Note that this requires a set, since a mask is not possible with
+        sub-contexts.
+
+        The "final" context mask which will be seen by OutputManager is the
+        combination of all regular contexts plus the masks of all sub-contexts.
+
+        @remark
+        It would have been possible to implement filtering of sub-contexts
+        directly in OutputListener and even to make OutputManager aware of
+        sub-contexts. This would reduce the amount of unnecessarily generated
+        output, but also increase the complexity of the checks whether some
+        output is needed.
+        On the other hand, filtering of sub-contexts makes the whole concept
+        more complicated, as it adds another mask and a set. So to keep it
+        clean and simple I figured it's best to put sub-context filtering into
+        a seaparate class.
+    */
+    class _UtilExport SubcontextOutputListener : public OutputListener
+    {
+        public:
+            SubcontextOutputListener(bool bRegister = true);
+            virtual ~SubcontextOutputListener();
+
+            void setAdditionalContextsMask(OutputContextMask mask);
+            void setAdditionalSubcontexts(const std::set<const OutputContextContainer*>& subcontexts);
+
+            virtual bool acceptsOutput(OutputLevel level, const OutputContextContainer& context) const;
+
+        private:
+            OutputContextMask subcontextsCheckMask_;    ///< All contexts defined by this mask need to be checked whether they are accepted by the set of sub-contexts
+            OutputContextMask subcontextsNoCheckMask_;  ///< All contexts defined by this mask don't need to be checked since we accept all sub-contexts
+            std::set<OutputContextSubID> subcontexts_;  ///< The set of accepted sub-contexts
+    };
+}
+
+#endif /* _SubcontextOutputListener_H__ */
Index: code/trunk/src/modules/designtools/ScreenshotManager.cc
===================================================================
--- code/trunk/src/modules/designtools/ScreenshotManager.cc	(revision 8857)
+++ code/trunk/src/modules/designtools/ScreenshotManager.cc	(revision 8858)
@@ -153,8 +153,8 @@
             finalImage->save(PathConfig::getInstance().getLogPathString() + "screenshot_" + getTimestamp() + this->fileExtension_);
             delete finalImage;
-            COUT(3) << "Finished taking " << this->gridSize_*this->windowWidth_ << "x" << this->gridSize_*this->windowHeight_ << " pixel HD screenshot. Storing in log/." << endl;
+            orxout(user_info) << "Finished taking " << this->gridSize_*this->windowWidth_ << "x" << this->gridSize_*this->windowHeight_ << " pixel HD screenshot. Storing in log/." << endl;
         }
         else
-            COUT(1) << "There needs to be an active camera to make screenshots." << endl;
+            orxout(user_error) << "There needs to be an active camera to make screenshots." << endl;
 
         this->cleanup();
@@ -257,5 +257,5 @@
                 this->buffer_->blitToMemory(this->finalPicturePB_->getSubVolume(subBox));
                 
-                COUT(4) << "Created screenshot number " << nbScreenshots << " for multi grid HD screenshot." << endl;
+                orxout(internal_info) << "Created screenshot number " << nbScreenshots << " for multi grid HD screenshot." << endl;
                 
             }
Index: code/trunk/src/modules/designtools/SkyboxGenerator.cc
===================================================================
--- code/trunk/src/modules/designtools/SkyboxGenerator.cc	(revision 8857)
+++ code/trunk/src/modules/designtools/SkyboxGenerator.cc	(revision 8858)
@@ -149,5 +149,5 @@
             else
             {
-                COUT(1) << "You must be in a level to generate a skybox." << endl;
+                orxout(user_error) << "You must be in a level to generate a skybox." << endl;
                 this->bGenerateSkybox_ = false;
                 return;
@@ -175,5 +175,5 @@
                 Ogre::ResourceGroupManager::getSingleton().addResourceLocation(PathConfig::getInstance().getLogPathString(), "FileSystem", Resource::getDefaultResourceGroup());
                 
-                COUT(4) << "Setting up SkyboxGenerator..." << endl;
+                orxout(internal_status) << "Setting up SkyboxGenerator..." << endl;
                 
                 this->bSetup_ = false;
@@ -194,5 +194,5 @@
                     entity->pitch(Degree((float)rotate.second));
                 
-                COUT(4) << "Created face number " << this->faceCounter_ << "." << endl;
+                orxout(internal_info) << "Created face number " << this->faceCounter_ << "." << endl;
                 // Check whether we've generated all 6 faces.
                 if(++this->faceCounter_ >= 6)
@@ -225,5 +225,5 @@
                 CommandExecutor::execute("pause");
                 
-                COUT(3) << "Skybox with face size " << this->size_ << "x" << this->size_ << " pixels created. Storing in log/." << endl;
+                orxout(user_info) << "Skybox with face size " << this->size_ << "x" << this->size_ << " pixels created. Storing in log/." << endl;
             }
         }
Index: code/trunk/src/modules/docking/Dock.cc
===================================================================
--- code/trunk/src/modules/docking/Dock.cc	(revision 8857)
+++ code/trunk/src/modules/docking/Dock.cc	(revision 8858)
@@ -87,5 +87,5 @@
         {
             if(!pTrigger->isForPlayer()) {  // The PlayerTrigger is not exclusively for Pawns which means we cannot extract one.
-                COUT(4) << "Docking:execute PlayerTrigger was not triggered by a player.." << std::endl;
+                orxout(verbose, context::docking) << "Docking:execute PlayerTrigger was not triggered by a player.." << endl;
                 return false;
             }
@@ -94,10 +94,10 @@
         else
         {
-            COUT(4) << "Docking::execute Not a player trigger, can't extract pawn from it.." << std::endl;
+            orxout(verbose, context::docking) << "Docking::execute Not a player trigger, can't extract pawn from it.." << endl;
             return false;
         }
         if(player == NULL)
         {
-            COUT(4) << "Docking::execute Can't retrieve PlayerInfo from Trigger. (" << trigger->getIdentifier()->getName() << ")" << std::endl;
+            orxout(verbose, context::docking) << "Docking::execute Can't retrieve PlayerInfo from Trigger. (" << trigger->getIdentifier()->getName() << ")" << endl;
             return false;
         }
@@ -168,5 +168,5 @@
         if(candidates_.find(player) == candidates_.end())
         {
-            COUT(2) << "Dock::dock Player is not a candidate!" << std::endl;
+            orxout(internal_warning, context::docking) << "Dock::dock Player is not a candidate!" << endl;
             return false;
         }
@@ -187,5 +187,5 @@
         if(docked_.find(player) == docked_.end())
         {
-            COUT(2) << "Dock::dockingAnimationFinished Player is not currently docked." << std::endl;
+            orxout(internal_warning, context::docking) << "Dock::dockingAnimationFinished Player is not currently docked." << endl;
             return false;
         }
@@ -200,5 +200,5 @@
         if(docked_.find(player) == docked_.end())
         {
-            COUT(2) << "Dock::undock Player is not docked to this Dock." << std::endl;
+            orxout(internal_warning, context::docking) << "Dock::undock Player is not docked to this Dock." << endl;
             return false;
         }
@@ -218,5 +218,5 @@
 
     bool Dock::undockingAnimationFinished(PlayerInfo* player) {
-        COUT(4) << "Dock::undockingAnimationFinished executed" << std::endl;
+        orxout(verbose, context::docking) << "Dock::undockingAnimationFinished executed" << endl;
         return true;
     }
Index: code/trunk/src/modules/docking/DockToShip.cc
===================================================================
--- code/trunk/src/modules/docking/DockToShip.cc	(revision 8857)
+++ code/trunk/src/modules/docking/DockToShip.cc	(revision 8858)
@@ -43,5 +43,5 @@
     {
         RegisterObject(DockToShip);
-        COUT(4) << "DockToShip instance created.." << endl;
+        orxout(verbose, context::docking) << "DockToShip instance created.." << endl;
     }
 
@@ -69,9 +69,9 @@
     bool DockToShip::docking(PlayerInfo* player)
     {
-        COUT(4) << "DockToShip::attach" << endl;
+        orxout(verbose, context::docking) << "DockToShip::attach" << endl;
 
         DockingTarget *target = DockingEffect::findTarget(this->target_);
         if (target == NULL) {
-            COUT(0) << "Can't retrieve target for '" << this->target_ << "'.." << std::endl;
+            orxout(internal_warning, context::docking) << "Can't retrieve target for '" << this->target_ << "'.." << endl;
             return false;
         }
@@ -79,5 +79,5 @@
         ControllableEntity *dockTo = (ControllableEntity*) target->getParent();
         if (dockTo == NULL) {
-            COUT(2) << "Parent is not a ControllableEntity.." << std::endl;
+            orxout(internal_warning, context::docking) << "Parent is not a ControllableEntity.." << endl;
             return false;
         }
@@ -92,5 +92,5 @@
     bool DockToShip::release(PlayerInfo* player)
     {
-        COUT(4) << "DockToShip::release" << endl;
+        orxout(verbose, context::docking) << "DockToShip::release" << endl;
 
         player->stopTemporaryControl();
Index: code/trunk/src/modules/docking/DockingController.cc
===================================================================
--- code/trunk/src/modules/docking/DockingController.cc	(revision 8857)
+++ code/trunk/src/modules/docking/DockingController.cc	(revision 8858)
@@ -97,5 +97,5 @@
         if (docking)
         {
-            COUT(4) << "DockingController::takeControl Taking over control." << std::endl;
+            orxout(verbose, context::docking) << "DockingController::takeControl Taking over control." << endl;
 
             this->entity_->setDestroyWhenPlayerLeft(false);
@@ -108,5 +108,5 @@
     void DockingController::positionReached()
     {
-        COUT(4) << "DockingController::positionReached() called." << std::endl;
+        orxout(verbose, context::docking) << "DockingController::positionReached() called." << endl;
 
         assert(this->player_);
Index: code/trunk/src/modules/docking/DockingTarget.cc
===================================================================
--- code/trunk/src/modules/docking/DockingTarget.cc	(revision 8857)
+++ code/trunk/src/modules/docking/DockingTarget.cc	(revision 8858)
@@ -53,5 +53,5 @@
         SUPER(DockingTarget, XMLPort, xmlelement, mode);
 
-        COUT(4) << "DockingTarget with name '" << this->getName() << "' created.." << std::endl;
+        orxout(verbose, context::docking) << "DockingTarget with name '" << this->getName() << "' created.." << endl;
     }
 
Index: code/trunk/src/modules/gametypes/RaceCheckPoint.cc
===================================================================
--- code/trunk/src/modules/gametypes/RaceCheckPoint.cc	(revision 8857)
+++ code/trunk/src/modules/gametypes/RaceCheckPoint.cc	(revision 8858)
@@ -29,7 +29,8 @@
 #include "RaceCheckPoint.h"
 
+#include "util/Convert.h"
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
-#include "util/Convert.h"
+#include "chat/ChatManager.h"
 
 #include "SpaceRace.h"
@@ -110,7 +111,7 @@
             {
                 const std::string& message =  "You have " + multi_cast<std::string>(this->bTimeLimit_)
-                            + " seconds to reach the check point " + multi_cast<std::string>(this->bCheckpointIndex_+1) + "\n";
-                COUT(3) << message;
+                            + " seconds to reach the check point " + multi_cast<std::string>(this->bCheckpointIndex_+1);
                 const_cast<GametypeInfo*>(gametype->getGametypeInfo())->sendAnnounceMessage(message);
+                ChatManager::message(message);
             }
         }
Index: code/trunk/src/modules/gametypes/SpaceRace.cc
===================================================================
--- code/trunk/src/modules/gametypes/SpaceRace.cc	(revision 8857)
+++ code/trunk/src/modules/gametypes/SpaceRace.cc	(revision 8858)
@@ -30,5 +30,5 @@
 
 #include "core/CoreIncludes.h"
-#include "network/Host.h"
+#include "chat/ChatManager.h"
 #include "util/Convert.h"
 #include "util/Math.h"
@@ -54,10 +54,10 @@
             this->clock_.capture();
             int s = this->clock_.getSeconds();
-            int ms = this->clock_.getMilliseconds()-1000*s;
+            int ms = static_cast<int>(this->clock_.getMilliseconds()-1000*s);
             const std::string& message = multi_cast<std::string>(s) + "." + multi_cast<std::string>(ms) + " seconds !!\n"
                         + "You didn't reach the check point " + multi_cast<std::string>(this->checkpointsReached_+1)
                         + " before the time limit. You lose!";
-            COUT(3) << message;
             const_cast<GametypeInfo*>(this->getGametypeInfo())->sendAnnounceMessage(message);
+            ChatManager::message(message);
         }
         else
@@ -65,14 +65,16 @@
             this->clock_.capture();
             int s = this->clock_.getSeconds();
-            int ms = this->clock_.getMilliseconds()-1000*s;
+            int ms = static_cast<int>(this->clock_.getMilliseconds()-1000*s);
             const std::string& message = "You win!! You have reached the last check point after "+ multi_cast<std::string>(s)
                         + "." + multi_cast<std::string>(ms) + " seconds.";
-            COUT(3) << message << std::endl;
             const_cast<GametypeInfo*>(this->getGametypeInfo())->sendAnnounceMessage(message);
+            ChatManager::message(message);
+/*
             float time = this->clock_.getSecondsPrecise();
             this->scores_.insert(time);
             std::set<float>::iterator it;
             for (it=this->scores_.begin(); it!=this->scores_.end(); it++)
-            COUT(3) <<  multi_cast<std::string>(*it) << std::endl;
+                orxout(level::message) << multi_cast<std::string>(*it) << endl;
+*/
         }
     }
@@ -83,6 +85,6 @@
 
         std::string message("The match has started! Reach the check points as quickly as possible!");
-        COUT(3) << message << std::endl;
         const_cast<GametypeInfo*>(this->getGametypeInfo())->sendAnnounceMessage(message);
+        ChatManager::message(message);
     }
 
@@ -92,10 +94,10 @@
         this->clock_.capture();
         int s = this->clock_.getSeconds();
-        int ms = this->clock_.getMilliseconds()-1000*s;
+        int ms = static_cast<int>(this->clock_.getMilliseconds()-1000*s);
         const std::string& message = "Checkpoint " + multi_cast<std::string>(this->getCheckpointsReached())
                         + " reached after " + multi_cast<std::string>(s) + "." + multi_cast<std::string>(ms)
-                        + " seconds.\n";
-        COUT(3) << message;
+                        + " seconds.";
         const_cast<GametypeInfo*>(this->getGametypeInfo())->sendAnnounceMessage(message);
+        ChatManager::message(message);
     }
 
Index: code/trunk/src/modules/notifications/NotificationDispatcher.cc
===================================================================
--- code/trunk/src/modules/notifications/NotificationDispatcher.cc	(revision 8857)
+++ code/trunk/src/modules/notifications/NotificationDispatcher.cc	(revision 8858)
@@ -137,5 +137,5 @@
             return false;
 
-        COUT(4) << "NotificationDispatcher (&" << this << ") triggered." << std::endl;
+        orxout(verbose, context::notifications) << "NotificationDispatcher (&" << this << ") triggered." << endl;
 
         PlayerTrigger* pTrigger = orxonox_cast<PlayerTrigger*>(trigger);
@@ -155,5 +155,5 @@
         if(player == NULL)
         {
-            COUT(4) << "The NotificationDispatcher was triggered by an entity other than a Pawn. (" << trigger->getIdentifier()->getName() << ")" << std::endl;
+            orxout(verbose, context::notifications) << "The NotificationDispatcher was triggered by an entity other than a Pawn. (" << trigger->getIdentifier()->getName() << ")" << endl;
             return false;
         }
Index: code/trunk/src/modules/notifications/NotificationManager.cc
===================================================================
--- code/trunk/src/modules/notifications/NotificationManager.cc	(revision 8857)
+++ code/trunk/src/modules/notifications/NotificationManager.cc	(revision 8858)
@@ -57,5 +57,5 @@
         RegisterRootObject(NotificationManager);
 
-        COUT(3) << "NotificatioManager created." << std::endl;
+        orxout(internal_info, context::notifications) << "NotificatioManager created." << endl;
     }
 
@@ -71,5 +71,5 @@
         this->allNotificationsList_.clear();
 
-        COUT(3) << "NotificationManager destroyed." << std::endl;
+        orxout(internal_info, context::notifications) << "NotificationManager destroyed." << endl;
     }
 
@@ -132,5 +132,5 @@
 
         if(commandExecuted)
-            COUT(3) << "Notification command \"" << NotificationListener::command2Str(command) << "\" executed." << endl;
+            orxout(internal_info, context::notifications) << "Notification command \"" << NotificationListener::command2Str(command) << "\" executed." << endl;
 
         return commandExecuted;
@@ -198,5 +198,5 @@
         }
 
-        COUT(4) << "Notification (&" << notification << ") registered with the NotificationManager." << std::endl;
+        orxout(verbose, context::notifications) << "Notification (&" << notification << ") registered with the NotificationManager." << endl;
 
         return true;
@@ -219,5 +219,5 @@
         this->removeNotification(notification, *(this->notificationLists_.find(queue->getName())->second));
 
-        COUT(4) << "Notification (&" << notification << ") unregistered with the NotificationManager from NotificationQueue " << queue->getName() << "." << std::endl;
+        orxout(verbose, context::notifications) << "Notification (&" << notification << ") unregistered with the NotificationManager from NotificationQueue " << queue->getName() << "." << endl;
     }
 
@@ -351,5 +351,5 @@
         queue->update(); // Update the queue.
         
-        COUT(4) << "NotificationQueue '" << queue->getName() << "' registered with the NotificationManager." << std::endl;
+        orxout(verbose, context::notifications) << "NotificationQueue '" << queue->getName() << "' registered with the NotificationManager." << endl;
         return true;
     }
@@ -384,5 +384,5 @@
         this->notificationLists_.erase(queue->getName());
         
-        COUT(4) << "NotificationQueue '" << queue->getName() << "' unregistered with the NotificationManager." << std::endl;
+        orxout(verbose, context::notifications) << "NotificationQueue '" << queue->getName() << "' unregistered with the NotificationManager." << endl;
     }
 
